/[gentoo-x86]/eclass/mysql.eclass
Gentoo

Diff of /eclass/mysql.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.123 Revision 1.135
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.123 2009/12/10 01:27:59 robbat2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/mysql.eclass,v 1.135 2010/03/03 23:57:13 robbat2 Exp $
4 4
5# @ECLASS: mysql.eclass 5# @ECLASS: mysql.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Author: Francesco Riosa (Retired) <vivo@gentoo.org> 7# Author: Francesco Riosa (Retired) <vivo@gentoo.org>
8# Maintainers: MySQL Team <mysql-bugs@gentoo.org> 8# Maintainers: MySQL Team <mysql-bugs@gentoo.org>
16# phase hooks. 16# phase hooks.
17 17
18WANT_AUTOCONF="latest" 18WANT_AUTOCONF="latest"
19WANT_AUTOMAKE="latest" 19WANT_AUTOMAKE="latest"
20 20
21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator 21inherit eutils flag-o-matic gnuconfig autotools mysql_fx versionator toolchain-funcs
22
23# Shorten the path because the socket path length must be shorter than 107 chars
24# and we will run a mysql server during test phase
25S="${WORKDIR}/mysql"
26
27[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
28if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
29 EGIT_PROJECT=mysql-extras
30 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
31 inherit git
32fi
22 33
23case "${EAPI:-0}" in 34case "${EAPI:-0}" in
24 2) 35 2)
25 EXPORT_FUNCTIONS pkg_setup \ 36 EXPORT_FUNCTIONS pkg_setup \
26 src_unpack src_prepare \ 37 src_unpack src_prepare \
40 ;; 51 ;;
41 *) 52 *)
42 die "Unsupported EAPI: ${EAPI}" ;; 53 die "Unsupported EAPI: ${EAPI}" ;;
43esac 54esac
44 55
45# Shorten the path because the socket path length must be shorter than 107 chars
46# and we will run a mysql server during test phase
47S="${WORKDIR}/mysql"
48
49[[ "${MY_EXTRAS_VER}" == "latest" ]] && MY_EXTRAS_VER="20090228-0714Z"
50if [[ "${MY_EXTRAS_VER}" == "live" ]]; then
51 EGIT_PROJECT=mysql-extras
52 EGIT_REPO_URI="git://git.overlays.gentoo.org/proj/mysql-extras.git"
53 inherit git
54fi
55
56# @ECLASS-VARIABLE: MYSQL_VERSION_ID 56# @ECLASS-VARIABLE: MYSQL_VERSION_ID
57# @DESCRIPTION: 57# @DESCRIPTION:
58# MYSQL_VERSION_ID will be: 58# MYSQL_VERSION_ID will be:
59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99] 59# major * 10e6 + minor * 10e4 + micro * 10e2 + gentoo revision number, all [0..99]
60# This is an important part, because many of the choices the MySQL ebuild will do 60# This is an important part, because many of the choices the MySQL ebuild will do
83 MYSQL_COMMUNITY_FEATURES=1 83 MYSQL_COMMUNITY_FEATURES=1
84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then 84elif [ "${PV#5.0}" != "${PV}" ] && mysql_version_is_at_least "5.0.82"; then
85 MYSQL_COMMUNITY_FEATURES=1 85 MYSQL_COMMUNITY_FEATURES=1
86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then 86elif [ "${PV#5.1}" != "${PV}" ] && mysql_version_is_at_least "5.1.28"; then
87 MYSQL_COMMUNITY_FEATURES=1 87 MYSQL_COMMUNITY_FEATURES=1
88elif [ "${PV#5.4}" != "${PV}" ]; then 88elif [ "${PV#5.4}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1
90elif [ "${PV#5.5}" != "${PV}" ] ; then
91 MYSQL_COMMUNITY_FEATURES=1
92elif [ "${PV#6.0}" != "${PV}" ] ; then
89 MYSQL_COMMUNITY_FEATURES=1 93 MYSQL_COMMUNITY_FEATURES=1
90else 94else
91 MYSQL_COMMUNITY_FEATURES=0 95 MYSQL_COMMUNITY_FEATURES=0
92fi 96fi
93 97
134# For other stuff to bring us in 138# For other stuff to bring us in
135PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})" 139PDEPEND="${PDEPEND} =virtual/mysql-$(get_version_component_range 1-2 ${PV})"
136 140
137# Work out the default SERVER_URI correctly 141# Work out the default SERVER_URI correctly
138if [ -z "${SERVER_URI}" ]; then 142if [ -z "${SERVER_URI}" ]; then
143 [ -z "${MY_PV}" ] && MY_PV="${PV//_/-}"
139 # The community build is on the mirrors 144 # The community build is on the mirrors
140 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then 145 if [ "${MYSQL_COMMUNITY_FEATURES}" == "1" ]; then
141 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${PV//_/-}.tar.gz" 146 SERVER_URI="mirror://mysql/Downloads/MySQL-${PV%.*}/mysql-${MY_PV}.tar.gz"
142 # The (old) enterprise source is on the primary site only 147 # The (old) enterprise source is on the primary site only
143 elif [ "${PN}" == "mysql" ]; then 148 elif [ "${PN}" == "mysql" ]; then
144 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${PV//_/-}.tar.gz" 149 SERVER_URI="ftp://ftp.mysql.com/pub/mysql/src/mysql-${MY_PV}.tar.gz"
145 fi 150 fi
146fi 151fi
147 152
148# Define correct SRC_URIs 153# Define correct SRC_URIs
149SRC_URI="${SERVER_URI}" 154SRC_URI="${SERVER_URI}"
150 155
151# Gentoo patches to MySQL 156# Gentoo patches to MySQL
152[[ ${MY_EXTRAS_VER} != live ]] \ 157[[ ${MY_EXTRAS_VER} != live ]] \
153&& SRC_URI="${SRC_URI} 158&& SRC_URI="${SRC_URI}
154 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2 159 mirror://gentoo/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
155 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2" 160 http://g3nt8.org/patches/mysql-extras-${MY_EXTRAS_VER}.tar.bz2
161 http://dev.gentoo.org/~robbat2/distfiles/mysql-extras-${MY_EXTRAS_VER}.tar.bz2"
162
163DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
164HOMEPAGE="http://www.mysql.com/"
165LICENSE="GPL-2"
166SLOT="0"
167IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static test"
168
169mysql_version_is_at_least "4.1" \
170&& IUSE="${IUSE} latin1"
171
172mysql_version_is_at_least "4.1.3" \
173&& IUSE="${IUSE} cluster extraengine"
174
175mysql_version_is_at_least "5.0" \
176|| IUSE="${IUSE} raid"
177
178mysql_version_is_at_least "5.0.18" \
179&& IUSE="${IUSE} max-idx-128"
180
181mysql_version_is_at_least "5.1" \
182|| IUSE="${IUSE} berkdb"
183
184[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
185&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
156 186
157# PBXT engine 187# PBXT engine
158mysql_version_is_at_least "5.1.12" \ 188mysql_version_is_at_least "5.1.12" \
159&& [[ -n "${PBXT_VERSION}" ]] \ 189&& [[ -n "${PBXT_VERSION}" ]] \
160&& PBXT_P="pbxt-${PBXT_VERSION}" \ 190&& PBXT_P="pbxt-${PBXT_VERSION}" \
161&& PBXT_SRC_URI="mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \ 191&& PBXT_SRC_URI="http://www.primebase.org/download/${PBXT_P}.tar.gz mirror://sourceforge/pbxt/${PBXT_P}.tar.gz" \
162&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" 192&& SRC_URI="${SRC_URI} pbxt? ( ${PBXT_SRC_URI} )" \
193&& IUSE="${IUSE} pbxt"
163 194
164# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set 195# Get the percona tarball if XTRADB_VER and PERCONA_VER are both set
165mysql_version_is_at_least "5.1.26" \ 196mysql_version_is_at_least "5.1.26" \
166&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \ 197&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
167&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \ 198&& XTRADB_P="percona-xtradb-${XTRADB_VER}" \
199&& XTRADB_SRC_URI_COMMON="${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \
200&& XTRADB_SRC_URI1="http://www.percona.com/percona-builds/xtradb/${XTRADB_SRC_URI_COMMON}" \
168&& XTRADB_SRC_URI="http://www.percona.com/${PN}/xtradb/${PERCONA_VER}/source/${XTRADB_P}.tar.gz" \ 201&& XTRADB_SRC_URI2="http://www.percona.com/${PN}/xtradb/${XTRADB_SRC_URI_COMMON}" \
169&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI} )" 202&& SRC_URI="${SRC_URI} xtradb? ( ${XTRADB_SRC_URI1} ${XTRADB_SRC_URI2} )" \
170
171DESCRIPTION="A fast, multi-threaded, multi-user SQL database server."
172HOMEPAGE="http://www.mysql.com/"
173LICENSE="GPL-2"
174SLOT="0"
175IUSE="big-tables debug embedded minimal ${IUSE_DEFAULT_ON}perl selinux ssl static"
176
177mysql_version_is_at_least "4.1" \
178&& IUSE="${IUSE} latin1"
179
180mysql_version_is_at_least "4.1.3" \
181&& IUSE="${IUSE} cluster extraengine"
182
183mysql_version_is_at_least "5.0" \
184|| IUSE="${IUSE} raid"
185
186mysql_version_is_at_least "5.0.18" \
187&& IUSE="${IUSE} max-idx-128"
188
189mysql_version_is_at_least "5.1" \
190|| IUSE="${IUSE} berkdb"
191
192mysql_version_is_at_least "5.1.12" \
193&& [[ -n "${PBXT_VERSION}" ]] \
194&& IUSE="${IUSE} pbxt"
195
196mysql_version_is_at_least "5.1.26" \
197&& [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
198&& IUSE="${IUSE} xtradb" 203&& IUSE="${IUSE} xtradb"
199
200[ "${MYSQL_COMMUNITY_FEATURES}" == "1" ] \
201&& IUSE="${IUSE} ${IUSE_DEFAULT_ON}community profiling"
202 204
203# 205#
204# HELPER FUNCTIONS: 206# HELPER FUNCTIONS:
205# 207#
206 208
207# @FUNCTION: mysql_disable_test 209# @FUNCTION: mysql_disable_test
208# @DESCRIPTION: 210# @DESCRIPTION:
209# Helper function to disable specific tests. 211# Helper function to disable specific tests.
210mysql_disable_test() { 212mysql_disable_test() {
213 local rawtestname testname testsuite reason mysql_disable_file
211 local testname="${1}" ; shift 214 rawtestname="${1}" ; shift
212 local reason="${@}" 215 reason="${@}"
216 ewarn "test '${rawtestname}' disabled: '${reason}'"
217
218 testsuite="${rawtestname/.*}"
219 testname="${rawtestname/*.}"
213 local mysql_disable_file="${S}/mysql-test/t/disabled.def" 220 mysql_disable_file="${S}/mysql-test/t/disabled.def"
221 #einfo "rawtestname=${rawtestname} testname=${testname} testsuite=${testsuite}"
214 echo ${testname} : ${reason} >> "${mysql_disable_file}" 222 echo ${testname} : ${reason} >> "${mysql_disable_file}"
215 ewarn "test '${testname}' disabled: '${reason}'" 223
224 # ${S}/mysql-tests/t/disabled.def
225 #
226 # ${S}/mysql-tests/suite/federated/disabled.def
227 #
228 # ${S}/mysql-tests/suite/jp/t/disabled.def
229 # ${S}/mysql-tests/suite/ndb/t/disabled.def
230 # ${S}/mysql-tests/suite/rpl/t/disabled.def
231 # ${S}/mysql-tests/suite/parts/t/disabled.def
232 # ${S}/mysql-tests/suite/rpl_ndb/t/disabled.def
233 # ${S}/mysql-tests/suite/ndb_team/t/disabled.def
234 # ${S}/mysql-tests/suite/binlog/t/disabled.def
235 # ${S}/mysql-tests/suite/innodb/t/disabled.def
236 if [ -n "${testsuite}" ]; then
237 for mysql_disable_file in \
238 ${S}/mysql-test/suite/${testsuite}/disabled.def \
239 ${S}/mysql-test/suite/${testsuite}/t/disabled.def \
240 FAILED ; do
241 [ -f "${mysql_disable_file}" ] && break
242 done
243 if [ "${mysql_disabled_file}" != "FAILED" ]; then
244 echo "${testname} : ${reason}" >> "${mysql_disable_file}"
245 else
246 ewarn "Could not find testsuite disabled.def location for ${rawtestname}"
247 fi
248 fi
216} 249}
217 250
218# @FUNCTION: mysql_init_vars 251# @FUNCTION: mysql_init_vars
219# @DESCRIPTION: 252# @DESCRIPTION:
220# void mysql_init_vars() 253# void mysql_init_vars()
372 if use ssl ; then 405 if use ssl ; then
373 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio" 406 mysql_version_is_at_least "5.0.4" || myconf="${myconf} --with-vio"
374 fi 407 fi
375 408
376 if mysql_version_is_at_least "5.1.11" ; then 409 if mysql_version_is_at_least "5.1.11" ; then
377 myconf="${myconf} $(use_with ssl)" 410 myconf="${myconf} $(use_with ssl /usr)"
378 else 411 else
379 myconf="${myconf} $(use_with ssl openssl)" 412 myconf="${myconf} $(use_with ssl openssl)"
380 fi 413 fi
381 414
382 if mysql_version_is_at_least "5.0.60" ; then 415 if mysql_version_is_at_least "5.0.60" ; then
445 # readline.h instead of history.h 478 # readline.h instead of history.h
446 myconf="${myconf} $(use_with ssl)" 479 myconf="${myconf} $(use_with ssl)"
447 myconf="${myconf} --enable-assembler" 480 myconf="${myconf} --enable-assembler"
448 myconf="${myconf} --with-geometry" 481 myconf="${myconf} --with-geometry"
449 myconf="${myconf} --with-readline" 482 myconf="${myconf} --with-readline"
450 myconf="${myconf} --with-row-based-replication"
451 myconf="${myconf} --with-zlib=/usr/$(get_libdir)" 483 myconf="${myconf} --with-zlib-dir=/usr/"
452 myconf="${myconf} --without-pstack" 484 myconf="${myconf} --without-pstack"
453 use max-idx-128 && myconf="${myconf} --with-max-indexes=128" 485 use max-idx-128 && myconf="${myconf} --with-max-indexes=128"
454 486
455 # 5.1 introduces a new way to manage storage engines (plugins) 487 # 5.1 introduces a new way to manage storage engines (plugins)
456 # like configuration=none 488 # like configuration=none
457 local plugins="csv,myisam,myisammrg,heap" 489 local plugins="csv,myisam,myisammrg,heap"
458 if use extraengine ; then 490 if use extraengine ; then
459 # like configuration=max-no-ndb, archive and example removed in 5.1.11 491 # like configuration=max-no-ndb, archive and example removed in 5.1.11
492 # not added yet: ibmdb2i
493 # Not supporting as examples: example,daemon_example,ftexample
460 plugins="${plugins},archive,blackhole,example,federated,partition" 494 plugins="${plugins},archive,blackhole,federated,partition"
461 495
462 elog "Before using the Federated storage engine, please be sure to read" 496 elog "Before using the Federated storage engine, please be sure to read"
463 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html" 497 elog "http://dev.mysql.com/doc/refman/5.1/en/federated-limitations.html"
464 fi 498 fi
465 499
466 # Upstream specifically requests that InnoDB always be built. 500 # Upstream specifically requests that InnoDB always be built:
467 plugins="${plugins},innobase" 501 # - innobase, innodb_plugin
502 # Build falcon if available for 6.x series.
503 for i in innobase innodb_plugin falcon ; do
504 [ -e "${S}"/storage/${i} ] && plugins="${plugins},${i}"
505 done
468 506
469 # like configuration=max-no-ndb 507 # like configuration=max-no-ndb
470 if use cluster ; then 508 if use cluster ; then
471 plugins="${plugins},ndbcluster" 509 plugins="${plugins},ndbcluster"
472 myconf="${myconf} --with-ndb-binlog" 510 myconf="${myconf} --with-ndb-binlog"
473 fi 511 fi
474 512
475 if mysql_version_is_at_least "5.2" ; then
476 plugins="${plugins},falcon"
477 fi
478
479 myconf="${myconf} --with-plugins=${plugins}" 513 myconf="${myconf} --with-plugins=${plugins}"
514}
515
516xtradb_applicable() {
517 mysql_version_is_at_least "5.1.26" \
518 && [[ -n "${XTRADB_VER}" && -n "${PERCONA_VER}" ]] \
519 && use xtradb
520 return $?
521}
522
523pbxt_applicable() {
524 mysql_version_is_at_least "5.1.12" \
525 && [[ -n "${PBXT_VERSION}" ]] \
526 && use pbxt
527 return $?
480} 528}
481 529
482pbxt_src_configure() { 530pbxt_src_configure() {
483 mysql_init_vars 531 mysql_init_vars
484 532
486 534
487 einfo "Reconfiguring dir '${PWD}'" 535 einfo "Reconfiguring dir '${PWD}'"
488 AT_GNUCONF_UPDATE="yes" eautoreconf 536 AT_GNUCONF_UPDATE="yes" eautoreconf
489 537
490 local myconf="" 538 local myconf=""
491 myconf="${myconf} --with-mysql=${S} --libdir=${D}/${MY_LIBDIR}" 539 myconf="${myconf} --with-mysql=${S} --libdir=${MY_LIBDIR}"
492 use debug && myconf="${myconf} --with-debug=full" 540 use debug && myconf="${myconf} --with-debug=full"
493 # TODO: is it safe/needed to use econf here ? 541 # TODO: is it safe/needed to use econf here ?
494 ./configure ${myconf} || die "Problem configuring PBXT storage engine" 542 ./configure ${myconf} || die "Problem configuring PBXT storage engine"
495} 543}
496 544
506 # TODO: modify test suite for PBXT 554 # TODO: modify test suite for PBXT
507} 555}
508 556
509pbxt_src_install() { 557pbxt_src_install() {
510 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null 558 pushd "${WORKDIR}/pbxt-${PBXT_VERSION}" &>/dev/null
511 make install || die "Failed to install PBXT" 559 emake install DESTDIR="${D}" || die "Failed to install PBXT"
512 popd 560 popd
513} 561}
514 562
515# 563#
516# EBUILD FUNCTIONS 564# EBUILD FUNCTIONS
550 && use minimal ; then 598 && use minimal ; then
551 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 599 eerror "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
552 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!" 600 die "USE flags 'cluster' and 'extraengine' conflict with 'minimal' USE flag!"
553 fi 601 fi
554 602
603 # Bug #290570 fun. Upstream made us need a fairly new GCC4.
604 if mysql_version_is_at_least "5.0.83" ; then
605 GCC_VER=$(gcc-version)
606 case ${GCC_VER} in
607 2*|3*|4.0|4.1|4.2) die "Active GCC too old! Must have at least GCC4.3" ;;
608 esac
609 fi
610
555 # This should come after all of the die statements 611 # This should come after all of the die statements
556 enewgroup mysql 60 || die "problem adding 'mysql' group" 612 enewgroup mysql 60 || die "problem adding 'mysql' group"
557 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user" 613 enewuser mysql 60 -1 /dev/null mysql || die "problem adding 'mysql' user"
558 614
559 mysql_check_version_range "4.0 to 5.0.99.99" \ 615 mysql_check_version_range "4.0 to 5.0.99.99" \
560 && use berkdb \ 616 && use berkdb \
561 && elog "Berkeley DB support is deprecated and will be removed in future versions!" 617 && elog "Berkeley DB support is deprecated and will be removed in future versions!"
618
619 if [ "${PN}" != "mysql-cluster" ] && use cluster; then
620 ewarn "Upstream has noted that the NDB cluster support in the 5.0 and"
621 ewarn "5.1 series should NOT be put into production. In the near"
622 ewarn "future, it will be disabled from building."
623 ewarn ""
624 ewarn "If you need NDB support, you should instead move to the new"
625 ewarn "mysql-cluster package that represents that upstream NDB"
626 ewarn "development."
627 fi
562} 628}
563 629
564# @FUNCTION: mysql_src_unpack 630# @FUNCTION: mysql_src_unpack
565# @DESCRIPTION: 631# @DESCRIPTION:
566# Unpack the source code and call mysql_src_prepare for EAPI < 2. 632# Unpack the source code and call mysql_src_prepare for EAPI < 2.
595 # Now link in right patches 661 # Now link in right patches
596 mysql_mv_patches 662 mysql_mv_patches
597 # And apply 663 # And apply
598 epatch 664 epatch
599 665
666 # last -fPIC fixup, per bug #305873
667 i="${S}"/storage/innodb_plugin/plug.in
668 [ -f "${i}" ] && sed -i -e '/CFLAGS/s,-prefer-non-pic,,g' "${i}"
669
600 # Additional checks, remove bundled zlib 670 # Additional checks, remove bundled zlib
601 rm -f "${S}/zlib/"*.[ch] 671 rm -f "${S}/zlib/"*.[ch]
602 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in" 672 sed -i -e "s/zlib\/Makefile dnl/dnl zlib\/Makefile/" "${S}/configure.in"
603 rm -f "scripts/mysqlbug" 673 rm -f "scripts/mysqlbug"
604 674
617 rm -f "scripts/mysqlbug" 687 rm -f "scripts/mysqlbug"
618 fi 688 fi
619 689
620 local rebuilddirlist d 690 local rebuilddirlist d
621 691
622 if mysql_version_is_at_least "5.1.26" && use xtradb ; then 692 if xtradb_applicable ; then
623 einfo "Replacing InnoDB with Percona XtraDB" 693 einfo "Replacing InnoDB with Percona XtraDB"
624 pushd "${S}"/storage 694 pushd "${S}"/storage
625 i="innobase" 695 i="innobase"
626 o="${WORKDIR}/storage-${i}.mysql-upstream" 696 o="${WORKDIR}/storage-${i}.mysql-upstream"
627 # Have we been here already? 697 # Have we been here already?
628 [ -h "${i}" ] && rm -f "${i}" 698 [ -d "${o}" ] && rm -f "${i}"
629 # Or maybe we haven't 699 # Or maybe we haven't
630 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}" 700 [ -d "${i}" -a ! -d "${o}" ] && mv "${i}" "${o}"
631 ln -s "${WORKDIR}/${XTRADB_P}" "${i}" 701 cp -ra "${WORKDIR}/${XTRADB_P}" "${i}"
632 popd 702 popd
633 fi 703 fi
634 704
635 if mysql_version_is_at_least "5.1.12" ; then 705 if mysql_version_is_at_least "5.1.12" ; then
636 einfo "Updating innobase cmake"
637 rebuilddirlist="." 706 rebuilddirlist="."
707 # This does not seem to be needed presently. robbat2 2010/02/23
708 #einfo "Updating innobase cmake"
638 # TODO: check this with a cmake expert 709 ## TODO: check this with a cmake expert
639 cmake \ 710 #cmake \
640 -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \ 711 # -DCMAKE_C_COMPILER=$(type -P $(tc-getCC)) \
641 -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \ 712 # -DCMAKE_CXX_COMPILER=$(type -P $(tc-getCXX)) \
642 "storage/innobase" 713 # "storage/innobase"
643 else 714 else
644 rebuilddirlist=". innobase" 715 rebuilddirlist=". innobase"
645 fi 716 fi
646 717
647 for d in ${rebuilddirlist} ; do 718 for d in ${rebuilddirlist} ; do
731 find . -type f -name Makefile -print0 \ 802 find . -type f -name Makefile -print0 \
732 | xargs -0 -n100 sed -i \ 803 | xargs -0 -n100 sed -i \
733 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|' 804 -e 's|^pkglibdir *= *$(libdir)/mysql|pkglibdir = $(libdir)|;s|^pkgincludedir *= *$(includedir)/mysql|pkgincludedir = $(includedir)|'
734 805
735 if [[ $EAPI == 2 ]]; then 806 if [[ $EAPI == 2 ]]; then
736 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_configure 807 pbxt_applicable && pbxt_src_configure
737 fi 808 fi
738} 809}
739 810
740# @FUNCTION: mysql_src_compile 811# @FUNCTION: mysql_src_compile
741# @DESCRIPTION: 812# @DESCRIPTION:
747 0 | 1) mysql_src_configure ;; 818 0 | 1) mysql_src_configure ;;
748 esac 819 esac
749 820
750 emake || die "emake failed" 821 emake || die "emake failed"
751 822
752 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_compile 823 pbxt_applicable && pbxt_src_compile
753} 824}
754 825
755# @FUNCTION: mysql_src_install 826# @FUNCTION: mysql_src_install
756# @DESCRIPTION: 827# @DESCRIPTION:
757# Install mysql. 828# Install mysql.
758mysql_src_install() { 829mysql_src_install() {
759 # Make sure the vars are correctly initialized 830 # Make sure the vars are correctly initialized
760 mysql_init_vars 831 mysql_init_vars
761 832
762 emake install DESTDIR="${D}" benchdir_root="${MY_SHAREDSTATEDIR}" || die "emake install failed" 833 emake install \
834 DESTDIR="${D}" \
835 benchdir_root="${MY_SHAREDSTATEDIR}" \
836 testroot="${MY_SHAREDSTATEDIR}" \
837 || die "emake install failed"
763 838
764 mysql_version_is_at_least "5.1.12" && use pbxt && pbxt_src_install 839 pbxt_applicable && pbxt_src_install
765 840
766 # Convenience links 841 # Convenience links
767 einfo "Making Convenience links for mysqlcheck multi-call binary" 842 einfo "Making Convenience links for mysqlcheck multi-call binary"
768 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze" 843 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlanalyze"
769 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair" 844 dosym "/usr/bin/mysqlcheck" "/usr/bin/mysqlrepair"
773 einfo "Removing duplicate /usr/share/mysql files" 848 einfo "Removing duplicate /usr/share/mysql files"
774 rm -Rf "${D}/usr/share/info" 849 rm -Rf "${D}/usr/share/info"
775 for removeme in "mysql-log-rotate" mysql.server* \ 850 for removeme in "mysql-log-rotate" mysql.server* \
776 binary-configure* my-*.cnf mi_test_all* 851 binary-configure* my-*.cnf mi_test_all*
777 do 852 do
778 rm -f "${D}"/usr/share/mysql/${removeme} 853 rm -f "${D}"/${MY_SHAREDSTATEDIR}/${removeme}
779 done 854 done
780 855
781 # Clean up stuff for a minimal build 856 # Clean up stuff for a minimal build
782 if use minimal ; then 857 if use minimal ; then
783 einfo "Remove all extra content for minimal build" 858 einfo "Remove all extra content for minimal build"
784 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench} 859 rm -Rf "${D}${MY_SHAREDSTATEDIR}"/{mysql-test,sql-bench}
785 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam} 860 rm -f "${D}"/usr/bin/{mysql{_install_db,manager*,_secure_installation,_fix_privilege_tables,hotcopy,_convert_table_format,d_multi,_fix_extensions,_zap,_explain_log,_tableinfo,d_safe,_install,_waitpid,binlog,test},myisam*,isam*,pack_isam}
786 rm -f "${D}/usr/sbin/mysqld" 861 rm -f "${D}/usr/sbin/mysqld"
787 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a 862 rm -f "${D}${MY_LIBDIR}"/lib{heap,merge,nisam,my{sys,strings,sqld,isammrg,isam},vio,dbug}.a
863 fi
864
865 # Unless they explicitly specific USE=test, then do not install the
866 # testsuite. It DOES have a use to be installed, esp. when you want to do a
867 # validation of your database configuration after tuning it.
868 if use !test ; then
869 rm -rf "${D}"/${MY_SHAREDSTATEDIR}/mysql-test
788 fi 870 fi
789 871
790 # Configuration stuff 872 # Configuration stuff
791 if mysql_version_is_at_least "4.1" ; then 873 if mysql_version_is_at_least "4.1" ; then
792 mysql_mycnf_version="4.1" 874 mysql_mycnf_version="4.1"
823 done 905 done
824 fi 906 fi
825 907
826 # Docs 908 # Docs
827 einfo "Installing docs" 909 einfo "Installing docs"
828 dodoc README COPYING ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE 910 dodoc README ChangeLog EXCEPTIONS-CLIENT INSTALL-SOURCE
829 doinfo "${S}"/Docs/mysql.info 911 doinfo "${S}"/Docs/mysql.info
830 912
831 # Minimal builds don't have the MySQL server 913 # Minimal builds don't have the MySQL server
832 if ! use minimal ; then 914 if ! use minimal ; then
833 einfo "Including support files and sample configurations" 915 einfo "Including support files and sample configurations"
835 for script in \ 917 for script in \
836 "${S}"/support-files/my-*.cnf \ 918 "${S}"/support-files/my-*.cnf \
837 "${S}"/support-files/magic \ 919 "${S}"/support-files/magic \
838 "${S}"/support-files/ndb-config-2-node.ini 920 "${S}"/support-files/ndb-config-2-node.ini
839 do 921 do
840 dodoc "${script}" 922 [[ -f "$script" ]] && dodoc "${script}"
841 done 923 done
842 924
843 docinto "scripts" 925 docinto "scripts"
844 for script in "${S}"/scripts/mysql* ; do 926 for script in "${S}"/scripts/mysql* ; do
845 [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}" 927 [[ -f "$script" ]] && [[ "${script%.sh}" == "${script}" ]] && dodoc "${script}"
846 done 928 done
847 929
848 fi 930 fi
849 931
850 mysql_lib_symlinks "${D}" 932 mysql_lib_symlinks "${D}"
899 elog "\"emerge --config =${CATEGORY}/${PF}\"" 981 elog "\"emerge --config =${CATEGORY}/${PF}\""
900 elog "if this is a new install." 982 elog "if this is a new install."
901 einfo 983 einfo
902 fi 984 fi
903 985
904 if mysql_version_is_at_least "5.1.12" && use pbxt ; then 986 if pbxt_applicable ; then
905 # TODO: explain it better 987 # TODO: explain it better
906 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';" 988 elog " mysql> INSTALL PLUGIN pbxt SONAME 'libpbxt.so';"
907 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;" 989 elog " mysql> CREATE TABLE t1 (c1 int, c2 text) ENGINE=pbxt;"
908 elog "if, after that, you cannot start the MySQL server," 990 elog "if, after that, you cannot start the MySQL server,"
909 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then" 991 elog "remove the ${MY_DATADIR}/mysql/plugin.* files, then"

Legend:
Removed from v.1.123  
changed lines
  Added in v.1.135

  ViewVC Help
Powered by ViewVC 1.1.20